Const gfx_w=800,gfx_h=600
Graphics3D gfx_w,gfx_h,0,2
SetBuffer BackBuffer()

Local timer=CreateTimer(50)

;Abgeschlankter und modifizierter Draw3D-Code fr Schatten
Global cam=CreateCamera()
CameraClsMode(cam,0,1)
Global pivot=CreatePivot()
PositionEntity pivot,gfx_w/(-20),gfx_h/(-20),gfx_w/20.0
ScaleEntity pivot,1/10.0,1/10.0,1
Global d3d_tex=LoadTexture("gfx\schatten.png",2)
Global d3d_mesh=CreateMesh(pivot)
Global d3d_surface=CreateSurface(d3d_mesh)
Global d3d_w=TextureWidth(d3d_tex)/2.0
Global d3d_h=TextureHeight(d3d_tex)/2.0
Global d3d_u1map=0+(0.25/d3d_w)
Global d3d_v1map=0+(0.25/d3d_h)
Global d3d_u2map=1-(0.25/d3d_w)
Global d3d_v2map=1-(0.25/d3d_h)
EntityTexture d3d_mesh,d3d_tex
TextureBlend d3d_tex,2
EntityFX d3d_mesh,1+2+8+16

;Graphiken
AutoMidHandle True
Local bg=LoadImage("gfx\bg.png")
Local menu=LoadImage("gfx\menu.jpg")
Local hud=LoadImage("gfx\anzeige.png")
MaskImage hud,255,0,255
SetFont LoadFont("Arial Black",24)
Local btn_startki=LoadImage("gfx\1playerbtn.png")
Local btn_start=LoadImage("gfx\startbtn.png")
Local btn_credits=LoadImage("gfx\creditsbtn.png")
Local btn_end=LoadImage("gfx\endbtn.png")
MaskImage btn_startki,255,0,255
MaskImage btn_start,255,0,255
MaskImage btn_credits,255,0,255
MaskImage btn_end,255,0,255
Global tester=CreateImage(1,1)
WritePixel 0,0,12345,ImageBuffer(tester)
Local mastimg=LoadImage("gfx\mast.png")
Local credits

;Spielvars
Global ballfall#=0
Local obj.obj
Local kigegner
Local collcount,lastcoll ;Um "Hngenbleiben" zu vermeiden
Local snd_pfeif=LoadSound("sfx\whistel.mp3")
Local snd_punch=LoadSound("sfx\punch.mp3")
Const BODEN=450
Const PLAYER_V=3
;Menuvars
Local mhit,mx,my

Type obj
	Field x,y
	Field img
	Field w,h
	Field v#
	Field min,max
	Field winkel
	Field vis
End Type
Global netz.obj=loadObject("netz.png",gfx_w/2,358)
Global player1.obj=loadObject("player1.png")
player1\min=0:player1\max=gfx_w/2-5
Global player2.obj=loadObject("player2.png")
player2\min=gfx_w/2+5:player2\max=gfx_w
Global ball.obj=loadObject("ball.png")
ball\v=8

;Spielbegrenzungen
createObject(0,gfx_h/2,2,gfx_h,180) ;Links
createObject(gfx_w,gfx_h/2,2,gfx_h,180) ;Rechts
;createObject(gfx_w/2,0,gfx_w,2,0) ;Oben
Local unten.obj=createObject(gfx_w/2,BODEN+20,gfx_w,10,0)
createObject(gfx_w/2,475,10,215,180) ;Mast (vom netz)

Color 0,0,0

;Menu
.menu
Global player1_points=0,player2_points=0
Repeat
	DrawBlock menu,gfx_w/2,gfx_h/2
	mhit=MouseHit(1)
	mx=MouseX():my=MouseY()
	
	;Starten
	If ImagesCollide(btn_start,160,504,0,tester,mx,my,0) Then
		DrawImage btn_startki,160,504
		If mhit Then
			kigegner=True
			Exit
		EndIf
	EndIf
	If ImagesCollide(btn_start,319,504,0,tester,mx,my,0) Then
		DrawImage btn_start,319,504
		If mhit Then
			kigegner=False
			Exit
		EndIf
	EndIf
	
	;Credits
	If ImagesCollide(btn_credits,479,504,0,tester,mx,my,0) Then
		DrawImage btn_credits,479,504
		If mhit Then
			credits=LoadImage("gfx\credits.jpg")
			MaskImage credits,255,0,255
			DrawImage credits,gfx_w/2,gfx_h/2
			Flip 0
			FreeImage credits
			FlushKeys();:FlushMouse()
			Repeat
				WaitTimer timer
			;Until GetMouse()<>0 Or GetKey()<>0
			Until KeyHit(1)
		EndIf
	EndIf
	
	;Ende
	If ImagesCollide(btn_end,639,504,0,tester,mx,my,0) Then
		DrawImage btn_end,639,504
		If mhit Then End
	EndIf
	
	Flip 0
	WaitTimer timer
Forever

reset()
;Hauptschleife
Repeat
	;Spielpause
	If KeyHit(25) Then
		FlushKeys()
		Repeat
			WaitTimer timer
		Until KeyHit(25) Or KeyHit(1)
		FlushKeys()
	EndIf
	
	;Steuerung
	If KeyDown(30) Then player1\x=player1\x-PLAYER_V
	If KeyDown(32) Then player1\x=player1\x+PLAYER_V
	If KeyDown(17) And player1\y=BODEN-player1\h/2 Then player1\v=-6
	
	If kigegner Then
		;KI
		If ball\x>gfx_w/2-50 And ball\x<gfx_w-player2\w Then
			If ball\y<BODEN-player1\h-50 And player2\y=BODEN-player2\h/2 Then player2\v=-6
			If ball\x<player2\x-15 Then player2\x=player2\x-PLAYER_V
			If ball\x>player2\x-15 Then player2\x=player2\x+PLAYER_V
		EndIf
	Else
		If KeyDown(203) Then player2\x=player2\x-PLAYER_V
		If KeyDown(205) Then player2\x=player2\x+PLAYER_V
		If KeyDown(200) And player2\y=BODEN-player2\h/2 Then player2\v=-6
	EndIf
	
	player1\y=player1\y+player1\v
	player2\y=player2\y+player2\v
	
	;Ballphysik
	ball\x=ball\x+ball\v*Cos(ball\winkel)
	ball\y=ball\y+ball\v*Sin(ball\winkel)+ballfall#
	ballfall#=ballfall#+0.15
	
	DrawBlock bg,gfx_w/2,gfx_h/2
	;Schatten mit 3D-Untersttzung zeichnen
	ClearSurface d3d_surface
	DrawShadow(player1\x+20+(BODEN-player1\y)/5)
	DrawShadow(player2\x+20+(BODEN-player2\y)/5)
	DrawShadow(ball\x+20+(BODEN-ball\y)/5)
	RenderWorld()
	
	collcount=0
	For obj=Each obj
		;Ballkollision
		If obj<>ball Then
			obj\v=obj\v+0.15
			If ImagesCollide(ball\img,ball\x,ball\y,0,obj\img,obj\x,obj\y,0) Then
				PlaySound(snd_punch)
				collcount=collcount+1
				If Handle(obj)=lastcoll Then ball\y=ball\y-3
				lastcoll=Handle(obj)
				ball\x=ball\x-ball\v*Cos(ball\winkel)
				ball\y=ball\y-ball\v*Sin(ball\winkel)-ballfall#
				If obj\v<0 Then ball\y=ball\y+obj\v
				If obj\vis Then
					ball\winkel=ATan2(ball\y-obj\y,ball\x-obj\x)
					ballfall#=0
				Else
					ball\winkel=obj\winkel-ball\winkel
					If obj=unten Then
						ballfall#=0
						PlaySound(snd_pfeif)
						;Punkten
						If ball\x<gfx_w/2 Then
							player2_points=player2_points+1
						Else
							player1_points=player1_points+1
						EndIf
						If player2_points=15 Or player1_points=15 Then Goto menu
						reset()
					EndIf
				EndIf
			EndIf
			If obj\vis And obj<>netz Then
				;Seitenbegrenzungen (fr Spieler)
				If obj\x<obj\min+obj\w/2 Then obj\x=obj\min+obj\w/2
				If obj\x>obj\max-obj\w/2 Then obj\x=obj\max-obj\w/2
			EndIf
		EndIf
		
		If obj\vis Then
			;Bodenbegrenzung fr Spieler
			If obj<>ball Then
				If obj\y>BODEN-obj\h/2 Then
					obj\y=BODEN-obj\h/2
					obj\v=0
				EndIf
			EndIf
			;Zeichnen
			DrawImage obj\img,obj\x,obj\y
		EndIf
	Next
	If collcount>1 Then ball\y=ball\y-3
	DrawBlock mastimg,gfx_w/2,470
	DrawImage hud,gfx_w/2,35
	Text gfx_w/2-30,35,player1_points,1,1
	Text gfx_w/2+30,35,player2_points,1,1
	
	WaitTimer timer
	Flip 0
Until KeyHit(1)
Goto menu

Function reset()
	player1\x=200
	player1\y=BODEN-player1\h/2
	player2\x=600
	player2\y=BODEN-player2\h/2
	player1\v=0
	player2\v=0
	If (player1_points+player2_points) Mod 2=0 Then
		ball\x=player1\x
	Else
		ball\x=player2\x
	EndIf
	ball\y=100
	ball\winkel=90
	ballfall=0
	FlushKeys()
End Function

Function loadObject.obj(path$,x=0,y=0)
	Local obj.obj=New obj
	obj\img=LoadImage("gfx\"+path$)
	obj\w=ImageWidth(obj\img)
	obj\h=ImageWidth(obj\img)
	obj\x=x:obj\y=y
	obj\vis=True
	Return obj
End Function

Function createObject.obj(x,y,w,h,winkel)
	Local obj.obj=New obj
	obj\img=CreateImage(w,h)
	SetBuffer ImageBuffer(obj\img)
	Rect 0,0,w,h,1
	SetBuffer BackBuffer()
	obj\x=x:obj\y=y
	obj\w=w:obj\h=h
	obj\winkel=winkel
	obj\vis=False
	Return obj
End Function

Function DrawShadow(x)
	Local DrawXPos1=d3d_w
	Local DrawYPos1=d3d_h
	Local DrawXPos2=d3d_w
	Local DrawYPos2=d3d_h
	Local DrawV0=AddVertex(d3d_surface,x-DrawXPos1,gfx_h-BODEN-10+DrawYPos1,0,d3d_u1map,d3d_v1map)
	Local DrawV1=AddVertex(d3d_surface,x+DrawXPos2,gfx_h-BODEN-10+DrawYPos2,0,d3d_u2map,d3d_v1map)
	Local DrawV2=AddVertex(d3d_surface,x+DrawXPos1,gfx_h-BODEN-10-DrawYPos1,0,d3d_u2map,d3d_v2map)
	Local DrawV3=AddVertex(d3d_surface,x-DrawXPos2,gfx_h-BODEN-10-DrawYPos2,0,d3d_u1map,d3d_v2map)
	VertexColor d3d_surface,DrawV0,255,255,255,0.5
	VertexColor d3d_surface,DrawV1,255,255,255,0.5
	VertexColor d3d_surface,DrawV2,255,255,255,0.5
	VertexColor d3d_surface,DrawV3,255,255,255,0.5
	AddTriangle d3d_surface,DrawV0,DrawV1,DrawV2
	AddTriangle d3d_surface,DrawV2,DrawV3,DrawV0
End Function
;~IDEal Editor Parameters:
;~F#39#F2#104#10E#11B
;~C#Blitz 3D