AppTitle "BunnyHopp"

Const GraphX = 640, GraphY = 480
Graphics GraphX, GraphY, 32, 2
SetBuffer BackBuffer()

imgPlayer = LoadAnimImage("Gfx\Fahrrad.png", 140, 152, 0, 4)
imgPlayerOnly = LoadAnimImage("Gfx\FahrradohneRad.png", 140, 152, 0, 4)
imgHindernisse = LoadAnimImage("Gfx\Hindernisse.png", 164, 137, 0, 4)
imgBoden = LoadImage("Gfx\Boden.png")
imgHintergrund = LoadImage("Gfx\Hintergrund.png")
imgHintergrund2 = LoadImage("Gfx\Hintergrund3a.png")
imgHintergrund3 = LoadImage("Gfx\Hintergrund1.png")
imgText = LoadAnimImage("Gfx\Text.png", 360, 72, 0, 3)
imgStory = LoadAnimImage("Gfx\Story.png", 350, 60, 0, 2)
imgMarathon = LoadAnimImage("Gfx\Marathon.png", 453, 60, 0, 2)
imgCredits = LoadImage("Gfx\Credits.png")
imgBeenden = LoadImage("Gfx\Beenden.png")
imgMaus = LoadImage("Gfx\Maus.png")
imgZeiger = LoadImage("Gfx\Zeiger.png")
imgZiel = LoadImage("Gfx\Ziel.png")
MaskImage imgHindernisse, 255, 0, 255

Arial = LoadFont("Arial", 48)
Doing = LoadSound("Sfx\Doing.mp3")
SetFont Arial

Type tHindernis
	Field X#, Y#
	Field Hindernis
	Field Hit
End Type

datei = ReadFile("Save\save.z99")
	iStory_Count = ReadShort(datei)
	iLeben_Count = ReadShort(datei)
	iMarathon_Count = ReadShort(datei)
CloseFile(datei)
Global iSave = 0

Global iSpiel_Modus = 0

Global iSchw_TimerTime
Global iSchw_TimerSet = 0
Global iSchw_Modus = 0
Dim iSchw_Speed#(3)
Global iSchw_Timer = 0
iSchw_Speed(0) = 0.55
iSchw_Speed(1) = 0.75
iSchw_Speed(2) = 0.42

Dim Hintergrund_X#(4)
Hintergrund_X(1) = 0

Global iPlayer_X = 70
Global iPlayer_Y = 320
Global iLeben = 3
Global iZiel = 0
Global iPlayer_Springen = 0
Global iPlayer_Anim = 0
Global Timer_Set = 0
Global Timer_Time
Global Timer = 0
Global iPlayer_SprungSpeed# = -1
Global Startzeit#
Global Schleifenzeit#
Global ms = MilliSecs()

SeedRnd MilliSecs()

Repeat
	Startzeit# = MilliSecs()
	Leertaste = KeyHit(57)
	MausX = MouseX()
	MausY = MouseY()
	MausH = MouseHit(1)
	Color 235, 171, 17
	If ChannelPlaying(music) = 0 Then music = PlayMusic("Sfx\music.mp3")
	
	If iSpiel_Modus > 1 Then
	
	If Timer_Set = 0 Then
		Timer_Time = Rnd(900, 3000)
		Timer_Set = 1
	EndIf
	
	If iSchw_TimerSet = 0 Then
		iSchw_TimerTime = 30000
		iSchw_TimerSet = 1
	EndIf
	
	Timer = Timer + Schleifenzeit
	iSchw_Timer = iSchw_Timer + Schleifenzeit
	
	If Timer > Timer_Time Then
		tHindernis.tHindernis = New tHindernis
		tHindernis\X = 700
		tHindernis\Y = 330
		If iZiel = 1 Then tHindernis\Hindernis = 3
		If iZiel = 0 Then tHindernis\Hindernis = Rnd(0,2)
		tHindernis\Hit = 0
		Timer_Set = 0
		Timer = 0
	EndIf
	
	If iSpiel_Modus = 2 And iSchw_Modus = 2 And iSchw_Timer > 28500 And iZiel = 0 Then
		Timer = Timer_Time
		iZiel = 1
	EndIf
	
	If iSchw_Timer > iSchw_TimerTime Then
		If iSpiel_Modus = 2 Then 
			iSchw_Modus = iSchw_Modus + 1
			If iSchw_Modus = 3 Then
				iSpiel_Modus = 1
				iStory_Count = 1
				If iLeben > iLeben_Count Then iLeben_Count = iLeben
				iSave = 0
			EndIf
		EndIf
		If iSpiel_Modus = 3 Then iSchw_Modus = Rnd(0,2)
		iSchw_TimerSet = 0
		iSchw_Timer = 0
		Timer_Time = 5000
		Timer_Set = 2
		Timer = 0
	EndIf
	EndIf
	
	If MilliSecs() > ms+150 Then
		ms = MilliSecs()
		iPlayer_Anim = (iPlayer_Anim+1) Mod 4
	EndIf
	
	If iPlayer_Springen = 0 And Leertaste Then iPlayer_Springen = 1
	If iPlayer_Springen = 1 Then springenSpieler()
	
	TileImage imgHintergrund, Hintergrund_X(3), 0
	Hintergrund_X(3) = Hintergrund_X(3) - SZ(iSchw_Speed(iSchw_Modus)/5)
	If Hintergrund_X(3) > 640 Then Hintergrund_X(3) = 0
	TileImage imgHintergrund3, Hintergrund_X(2), 0
	TileImage imgHintergrund2, Hintergrund_X(2), 0
	Hintergrund_X(2) = Hintergrund_X(2) - SZ(iSchw_Speed(iSchw_Modus)/3)
	If Hintergrund_X(2) > 960 Then Hintergrund_X(2) = 0
	TileImage imgBoden, Hintergrund_X(1), 0
	Hintergrund_X(1) = Hintergrund_X(1) - SZ(iSchw_Speed(iSchw_Modus))
	If Hintergrund_X(1) > 320 Then Hintergrund_X(1) = 0
	
	If iSpiel_Modus = 0 Then
		
		DrawImage imgStory, GraphX/2 - ImageWidth(imgStory)/2, (GraphY/5) * 1, Story_Pic
		DrawImage imgMarathon, GraphX/2 - ImageWidth(imgMarathon)/2, (GraphY/5) * 2, Marathon_Pic
		DrawImage imgCredits, GraphX/2 - ImageWidth(imgCredits)/2, (GraphY/5) * 3
		DrawImage imgBeenden, GraphX/2 - ImageWidth(imgBeenden)/2, (GraphY/5) * 4
		
		Story_Pic = 0
		Marathon_Pic = 0
		
		If ImageRectOverlap(imgMaus, MausX, MausY, GraphX/2 - ImageWidth(imgStory)/2, (GraphY/5) * 1, ImageWidth(imgStory), ImageHeight(imgStory)) Then
			Story_Pic = 1
			DrawImage imgPlayerOnly, GraphX/2 - ImageWidth(imgPlayerOnly)/2, (GraphY/5) * 1 - ImageHeight(imgPlayerOnly)/2, iPlayer_anim
			If MausH Then iSpiel_Modus = 2
		EndIf
		If ImageRectOverlap(imgMaus, MausX, MausY, GraphX/2 - ImageWidth(imgMarathon)/2, (GraphY/5) * 2, ImageWidth(imgMarathon), ImageHeight(imgMarathon)) Then
			Marathon_Pic = 1
			DrawImage imgPlayerOnly, GraphX/2 - 20, (GraphY/5) * 2 - ImageHeight(imgPlayerOnly)/2, iPlayer_anim
			If MausH Then iSpiel_Modus = 3
		EndIf
		If ImageRectOverlap(imgMaus, MausX, MausY, GraphX/2 - ImageWidth(imgCredits)/2, (GraphY/5) * 3, ImageWidth(imgCredits), ImageHeight(imgCredits)) And MausH Then iSpiel_Modus = 1
		If ImageRectOverlap(imgMaus, MausX, MausY, GraphX/2 - ImageWidth(imgBeenden)/2, (GraphY/5) * 4, ImageWidth(imgBeenden), ImageHeight(imgBeenden)) And MausH Then End
		
		DrawImage imgMaus, MausX, MausY
		DrawImage imgZeiger, MausX, MausY
	EndIf
	
	If iSpiel_Modus = 1 Then
		
		If iSave = 0
			datei = WriteFile("Save\save.z99")
				WriteShort datei, iStory_Count
				WriteShort datei, iLeben_Count
				WriteShort datei, iMarathon_Count
			CloseFile datei
			iSave = 1
		EndIf
		
		If KeyHit(14) Then
			iSave = 0
			iStory_Count = 0
			iLeben_Count = 0
			iMarathon_Count = 0
		EndIf
		
		Color 235, 89, 17
		If iStory_Count = 0 Then Text 50, GraphY/5, "Story geschafft: Nein"
		If iStory_Count = 1 Then
			Text 50, GraphY/5, "Story geschafft: Ja"
			Text GraphX/2, GraphY/5+50, "mit " + iLeben_Count + " Leben"
		EndIf
		Text 50, GraphY/5 + 100, "Marathon-Highscore: " + iMarathon_Count
		Color 235, 171, 17
		Text 50, GraphY/2, "Program and Graphics by"
		Text GraphX/2, GraphY/2 + 50, "Severin Bauer"
	EndIf
	
	If iSpiel_Modus > 1 Then
		For tHindernis.tHindernis = Each tHindernis
			DrawImage imgHindernisse, tHindernis\X, tHindernis\Y, tHindernis\Hindernis
			tHindernis\X = tHindernis\X - SZ(iSchw_Speed(iSchw_Modus))
			If ImagesCollide(imgPlayer, iPlayer_X, iPlayer_Y, 0, imgHindernisse, tHindernis\X, tHindernis\Y, tHindernis\Hindernis) And tHindernis\Hit = 0 Then
				tHindernis\Hit = 1
				PlaySound(Doing)
			EndIf
			If tHindernis\X < -164 Then
				If iSpiel_Modus = 3 Then iMarathon_Count_Now = iMarathon_Count_Now + 1
				If tHindernis\Hit = 1 Then iLeben = iLeben - 1
				Delete tHindernis
			EndIf
		Next
	
		If Timer_Set = 2 Then
			DrawImage imgText, 160, 100, iSchw_Modus
		EndIf
		
		Text 10, 10, "Leben: " + iLeben
		If iSpiel_Modus = 2 Then Text GraphX/2 - 50, 10, "Erreiche das Ziel"
		If iSpiel_Modus = 3 Then Text GraphX/2, 10, iMarathon_Count_Now
		DrawImage imgPlayer, iPlayer_X, iPlayer_Y, iPlayer_Anim
	EndIf
	
	If KeyHit(1) Or iLeben = 0 Then
		iSpiel_Modus = 0
		iSave = 0
		iLeben = 3
		iSchw_TimerSet = 0
		iSchw_Timer = 0
		Timer_Set = 0
		Timer = 0
		iSchw_Modus = 0
		iZiel = 0
		If iMarathon_Count_Now > iMarathon_Count Then iMarathon_Count = iMarathon_Count_Now
		iMarathon_Count_Now = 0
		For tHindernis.tHindernis = Each tHindernis
			Delete tHindernis
		Next
	EndIf
		
	Flip
	
	Schleifenzeit# = MilliSecs() - Startzeit#
Forever


Function springenSpieler()
	iPlayer_Y = iPlayer_Y + SZ(iPlayer_SprungSpeed)
	iPlayer_SprungSpeed = iPlayer_SprungSpeed + 0.04
	
	If iPlayer_Y > 320 Then
		iPlayer_Springen = 0
		iPlayer_Y = 320
		iPlayer_SprungSpeed = -1
	EndIf
End Function


Function SZ#(Speed#)
	Return Speed * Schleifenzeit
End Function